Skip to content
Start here

List Members

client.Accounts.Members.List(ctx, params) (*V4PagePaginationArray[Member], error)
GET/accounts/{account_id}/members

List all members of an account.

Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
SCIM ProvisioningAccount Settings WriteAccount Settings Read
ParametersExpand Collapse
params MemberListParams
AccountID param.Field[string]

Path param: Account identifier tag.

maxLength32
minLength32
Direction param.Field[MemberListParamsDirection]optional

Query param: Direction to order results.

const MemberListParamsDirectionAsc MemberListParamsDirection = "asc"
const MemberListParamsDirectionDesc MemberListParamsDirection = "desc"
Order param.Field[MemberListParamsOrder]optional

Query param: Field to order results by.

const MemberListParamsOrderUserFirstName MemberListParamsOrder = "user.first_name"
const MemberListParamsOrderUserLastName MemberListParamsOrder = "user.last_name"
const MemberListParamsOrderUserEmail MemberListParamsOrder = "user.email"
const MemberListParamsOrderStatus MemberListParamsOrder = "status"
Page param.Field[float64]optional

Query param: Page number of paginated results.

minimum1
PerPage param.Field[float64]optional

Query param: Maximum number of results per page.

maximum50
minimum5
Status param.Field[MemberListParamsStatus]optional

Query param: A member's status in the account.

const MemberListParamsStatusAccepted MemberListParamsStatus = "accepted"
const MemberListParamsStatusPending MemberListParamsStatus = "pending"
const MemberListParamsStatusRejected MemberListParamsStatus = "rejected"
ReturnsExpand Collapse
type Member struct{…}
ID stringoptional

Membership identifier tag.

maxLength32
Email stringoptional

The contact email address of the user.

maxLength90
Policies []MemberPolicyoptional

Access policy for the membership

ID stringoptional

Policy identifier.

Access MemberPoliciesAccessoptional

Allow or deny operations against the resources.

One of the following:
const MemberPoliciesAccessAllow MemberPoliciesAccess = "allow"
const MemberPoliciesAccessDeny MemberPoliciesAccess = "deny"
PermissionGroups []MemberPoliciesPermissionGroupoptional

A set of permission groups that are specified to the policy.

ID string

Identifier of the permission group.

Meta MemberPoliciesPermissionGroupsMetaoptional

Attributes associated to the permission group.

Key stringoptional
Value stringoptional
Name stringoptional

Name of the permission group.

ResourceGroups []MemberPoliciesResourceGroupoptional

A list of resource groups that the policy applies to.

ID string

Identifier of the resource group.

Scope []MemberPoliciesResourceGroupsScope

The scope associated to the resource group

Key string

This is a combination of pre-defined resource name and identifier (like Account ID etc.)

Objects []MemberPoliciesResourceGroupsScopeObject

A list of scope objects for additional context.

Key string

This is a combination of pre-defined resource name and identifier (like Zone ID etc.)

Meta MemberPoliciesResourceGroupsMetaoptional

Attributes associated to the resource group.

Key stringoptional
Value stringoptional
Name stringoptional

Name of the resource group.

Roles []Roleoptional

Roles assigned to this Member.

ID string

Role identifier tag.

maxLength32
Description string

Description of role's permissions.

Name string

Role name.

maxLength120
Permissions RolePermissions
Analytics PermissionGrantoptional
Read booloptional
Write booloptional
Billing PermissionGrantoptional
Read booloptional
Write booloptional
CachePurge PermissionGrantoptional
Read booloptional
Write booloptional
DNS PermissionGrantoptional
Read booloptional
Write booloptional
DNSRecords PermissionGrantoptional
Read booloptional
Write booloptional
LB PermissionGrantoptional
Read booloptional
Write booloptional
Logs PermissionGrantoptional
Read booloptional
Write booloptional
Organization PermissionGrantoptional
Read booloptional
Write booloptional
SSL PermissionGrantoptional
Read booloptional
Write booloptional
WAF PermissionGrantoptional
Read booloptional
Write booloptional
ZoneSettings PermissionGrantoptional
Read booloptional
Write booloptional
Zones PermissionGrantoptional
Read booloptional
Write booloptional
Status MemberStatusoptional

A member's status in the account.

One of the following:
const MemberStatusAccepted MemberStatus = "accepted"
const MemberStatusPending MemberStatus = "pending"
User MemberUseroptional

Details of the user associated to the membership.

Email string

The contact email address of the user.

maxLength90
ID stringoptional

Identifier

maxLength32
minLength32
FirstName stringoptional

User's first name

maxLength60
LastName stringoptional

User's last name

maxLength60
TwoFactorAuthenticationEnabled booloptional

Indicates whether two-factor authentication is enabled for the user account. Does not apply to API authentication.

List Members

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/accounts"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"),
    option.WithAPIEmail("user@example.com"),
  )
  page, err := client.Accounts.Members.List(context.TODO(), accounts.MemberListParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "4536bcfad5faccb111b47003c79917fa",
      "email": "user@example.com",
      "policies": [
        {
          "id": "f267e341f3dd4697bd3b9f71dd96247f",
          "access": "allow",
          "permission_groups": [
            {
              "id": "c8fed203ed3043cba015a93ad1616f1f",
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "Zone Read"
            },
            {
              "id": "82e64a83756745bbbb1c9c2701bf816b",
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "Magic Network Monitoring"
            }
          ],
          "resource_groups": [
            {
              "id": "6d7f2f5f5b1d4a0e9081fdc98d432fd1",
              "scope": [
                {
                  "key": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4",
                  "objects": [
                    {
                      "key": "com.cloudflare.api.account.zone.23f8d65290b24279ba6f44721b3eaad5"
                    }
                  ]
                }
              ],
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4"
            }
          ]
        }
      ],
      "roles": [
        {
          "id": "3536bcfad5faccb999b47003c79917fb",
          "description": "Administrative access to the entire Account",
          "name": "Account Administrator",
          "permissions": {
            "analytics": {
              "read": true,
              "write": false
            },
            "billing": {
              "read": true,
              "write": false
            },
            "cache_purge": {
              "read": true,
              "write": false
            },
            "dns": {
              "read": true,
              "write": false
            },
            "dns_records": {
              "read": true,
              "write": false
            },
            "lb": {
              "read": true,
              "write": false
            },
            "logs": {
              "read": true,
              "write": false
            },
            "organization": {
              "read": true,
              "write": false
            },
            "ssl": {
              "read": true,
              "write": false
            },
            "waf": {
              "read": true,
              "write": false
            },
            "zone_settings": {
              "read": true,
              "write": false
            },
            "zones": {
              "read": true,
              "write": true
            }
          }
        }
      ],
      "status": "accepted",
      "user": {
        "email": "user@example.com",
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "first_name": "John",
        "last_name": "Appleseed",
        "two_factor_authentication_enabled": true
      }
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "4536bcfad5faccb111b47003c79917fa",
      "email": "user@example.com",
      "policies": [
        {
          "id": "f267e341f3dd4697bd3b9f71dd96247f",
          "access": "allow",
          "permission_groups": [
            {
              "id": "c8fed203ed3043cba015a93ad1616f1f",
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "Zone Read"
            },
            {
              "id": "82e64a83756745bbbb1c9c2701bf816b",
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "Magic Network Monitoring"
            }
          ],
          "resource_groups": [
            {
              "id": "6d7f2f5f5b1d4a0e9081fdc98d432fd1",
              "scope": [
                {
                  "key": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4",
                  "objects": [
                    {
                      "key": "com.cloudflare.api.account.zone.23f8d65290b24279ba6f44721b3eaad5"
                    }
                  ]
                }
              ],
              "meta": {
                "key": "key",
                "value": "value"
              },
              "name": "com.cloudflare.api.account.eb78d65290b24279ba6f44721b3ea3c4"
            }
          ]
        }
      ],
      "roles": [
        {
          "id": "3536bcfad5faccb999b47003c79917fb",
          "description": "Administrative access to the entire Account",
          "name": "Account Administrator",
          "permissions": {
            "analytics": {
              "read": true,
              "write": false
            },
            "billing": {
              "read": true,
              "write": false
            },
            "cache_purge": {
              "read": true,
              "write": false
            },
            "dns": {
              "read": true,
              "write": false
            },
            "dns_records": {
              "read": true,
              "write": false
            },
            "lb": {
              "read": true,
              "write": false
            },
            "logs": {
              "read": true,
              "write": false
            },
            "organization": {
              "read": true,
              "write": false
            },
            "ssl": {
              "read": true,
              "write": false
            },
            "waf": {
              "read": true,
              "write": false
            },
            "zone_settings": {
              "read": true,
              "write": false
            },
            "zones": {
              "read": true,
              "write": true
            }
          }
        }
      ],
      "status": "accepted",
      "user": {
        "email": "user@example.com",
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "first_name": "John",
        "last_name": "Appleseed",
        "two_factor_authentication_enabled": true
      }
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}